'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.showAttachMgr = showAttachMgr;
exports.showAttachList = showAttachList;
var React = require('react');
var ReactDom = require('react-dom');
var AttachMgrModal = require("./mgr/AttachMgrModal");
var AttachListModal = require("./mgr/AttachListModal");

/** 
 * 调用附件管理功能
 * @param config
 * 配置项：
 * serverUrl 必填,服务端url，默认为http://60.205.12.0:81
 * sourceId  必填，单据id
 * billType 必填，单据类型
 * userId 选填，用户id
 * userName 选填，用户姓名
 * fileTypes 选填，文件分类，keyvalue形式，例如{[{'code':'1','name':'文档'},{'code':'2','name':'图片'},{'code':'3','name':'其他'}]}
 * showUploadBtn 选填，是否显示上传按钮
 * showDelBtn 选填，是否显示删除按钮
 * beforeUpload 选填，function（）
 * beforeDel 选填，function（filelist）
 */
function showAttachMgr(config) {
    var div = document.createElement('div');
    document.body.appendChild(div);

    var dialog = void 0;

    function close() {
        dialog.setState({
            visible: false
        });
        ReactDom.unmountComponentAtNode(div);
        div.parentNode.removeChild(div);
    }

    var props = config;
    props.onCancel = close;
    props.visible = true;
    ReactDom.render(React.createElement(AttachMgrModal, props), div, function () {
        dialog = this;
    });
}

/**
 * 调用附件列表功能
 * @param config
 * 配置项：
 * serverUrl 必填,服务端url，默认为http://60.205.12.0:81
 * sourceId  必填，单据id
 * billType 必填，单据类型
 * fileTypes 选填，文件分类，keyvalue形式，例如{[{'code':'1','name':'文档'},{'code':'2','name':'图片'},{'code':'3','name':'其他'}]}
 */
function showAttachList(config) {
    var div = document.createElement('div');
    document.body.appendChild(div);

    var dialog = void 0;

    function close() {
        dialog.setState({
            visible: false
        });
        ReactDom.unmountComponentAtNode(div);
        div.parentNode.removeChild(div);
    }

    var props = config;
    props.onCancel = close;
    props.visible = true;
    ReactDom.render(React.createElement(AttachListModal, props), div, function () {
        dialog = this;
    });
}