'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _yylibUi = require('yylib-ui');

var _ajax = require('yylib-utils/ajax');

var _ajax2 = _interopRequireDefault(_ajax);

var _jsCookie = require('js-cookie');

var _jsCookie2 = _interopRequireDefault(_jsCookie);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * ncc图片上传组件
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author xg
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var confirm = _yylibUi.YYModal.confirm;

var NccImageWall = function (_React$Component) {
    _inherits(NccImageWall, _React$Component);

    function NccImageWall(props) {
        _classCallCheck(this, NccImageWall);

        var _this2 = _possibleConstructorReturn(this, (NccImageWall.__proto__ || Object.getPrototypeOf(NccImageWall)).call(this, props));

        _this2.loadFiles = function () {
            var _this2$state = _this2.state,
                appCode = _this2$state.appCode,
                billId = _this2$state.billId;
            var _this2$props = _this2.props,
                serverUrl = _this2$props.serverUrl,
                queryUrl = _this2$props.queryUrl;

            if (appCode && billId) {
                var params = {
                    busiParamJson: JSON.stringify({
                        billId: '' + (appCode + '/' + billId),
                        fullPath: '' + (appCode + '/' + billId)
                    }),
                    sysParamJson: { appcode: appCode, pagecs: _jsCookie2.default.get("cookiets") }
                };
                _ajax2.default.postJSONWithCookies(serverUrl + queryUrl, params, function (result) {
                    if (result && result.success) {
                        var data = result.data || [];
                        var fileList = [];
                        data.map(function (file) {
                            fileList.push({
                                uid: file.pk_doc,
                                name: file.name,
                                url: "http://www.baidu.com",
                                thumbUrl: file.previewUrl,
                                status: 'done',
                                response: { data: [file], success: true }
                            });
                        });
                        _this2.setState({ files: fileList });
                    }
                });
            }
        };

        _this2.beforeUpload = function (file) {
            var retFlag = true;
            var _this2$props2 = _this2.props,
                accept = _this2$props2.accept,
                beforeUpload = _this2$props2.beforeUpload,
                serverUrl = _this2$props2.serverUrl,
                uploadUrl = _this2$props2.uploadUrl;
            // 1.校验附件服务基准地址和上传附件的服务地址

            if (!serverUrl || !uploadUrl) {
                _yylibUi.YYMessage.error("附件服务地址未配置,无法上传");
                return false;
            }
            // 2.校验文件大小
            if (file.size === 0) {
                _yylibUi.YYMessage.error("不允许上传空文件");
                return false;
            }
            // 3.校验文件格式
            if (accept) {
                var accpetSuffix = accept.split(",");
                var fileName = file.name;
                var suffix = fileName.substr(fileName.lastIndexOf("."), fileName.length);
                if (accpetSuffix.indexOf(suffix) === -1) {
                    _yylibUi.YYMessage.error("只允许上传" + accept + "格式的文件", 3);
                    return false;
                }
            }
            // 4.回调外部属性
            if (beforeUpload && typeof beforeUpload === "function") {
                retFlag = beforeUpload(file) || false;
            }
            return retFlag;
        };

        _this2.getUploadParams = function () {
            var _this2$state2 = _this2.state,
                appCode = _this2$state2.appCode,
                billId = _this2$state2.billId;

            return {
                billId: '' + (appCode + '/' + billId),
                fullPath: '' + (appCode + '/' + billId),
                sys_appcode: '' + appCode
            };
        };

        _this2.onChange = function (_ref) {
            var file = _ref.file,
                fileList = _ref.fileList;

            if (file && file.status === "done") {
                if (file.response && !file.response.success) {
                    _yylibUi.YYMessage.error(file.response.error && file.response.error.message ? file.response.error.message : "上传失败");
                }
            }
            fileList = fileList.map(function (file) {
                if (file.response) {
                    // 组件会将 file.url 作为链接进行展示
                    file.url = "http://www.baidu.com"; // 暂时不支持在线预览，所以不会用到该url
                }
                return file;
            });
            // 筛选成功上传的文件
            fileList = fileList.filter(function (file) {
                if (file.response) {
                    return file.response.success === true;
                }
                return true;
            });
            _this2.setState({ files: fileList }, _this2.changeValue);
        };

        _this2.onPreview = function (file) {
            _this2.setState({
                previewVisible: true,
                previewImage: file.thumbUrl
            });
        };

        _this2.onRemove = function (file) {
            var _this = _this2;
            var _this2$props3 = _this2.props,
                deleteTip = _this2$props3.deleteTip,
                serverUrl = _this2$props3.serverUrl,
                deleteUrl = _this2$props3.deleteUrl;
            var _this2$state3 = _this2.state,
                appCode = _this2$state3.appCode,
                files = _this2$state3.files;

            confirm({
                title: deleteTip,
                onOk: function onOk() {
                    var fileData = file.response.data[0];

                    var _ref2 = fileData || {},
                        billId = _ref2.billId,
                        fullPath = _ref2.fullPath,
                        pk_doc = _ref2.pk_doc;

                    var params = {
                        busiParamJson: JSON.stringify({
                            billId: billId,
                            fullPath: fullPath,
                            pk_doc: pk_doc
                        }),
                        sysParamJson: { appcode: appCode, pagecs: _jsCookie2.default.get("cookiets") }
                    };
                    _ajax2.default.postJSONWithCookies(serverUrl + deleteUrl, params, function (result) {
                        if (result && result.success) {
                            _this.setState({
                                files: files.filter(function (file) {
                                    // 从文件列表中移除删除的文件
                                    return file.response.data[0].pk_doc !== pk_doc;
                                })
                            }, _this.changeValue);
                        }
                    });
                }
            });
        };

        _this2.handleCancel = function () {
            _this2.setState({ previewVisible: false, previewImage: null });
        };

        _this2.state = {
            files: _this2.props.defaultFileList,
            serverUrl: _this2.props.serverUrl,
            appCode: _this2.props.appCode,
            billId: _this2.props.billId,
            disabled: _this2.props.disabled,
            previewVisible: false, // 是否显示预览图片的弹出层
            previewImage: null // 当前预览的图片
        };
        return _this2;
    }

    _createClass(NccImageWall, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (!this.props.defaultFileList || !this.props.defaultFileList.length) {
                this.loadFiles();
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.appCode && nextProps.appCode !== this.props.appCode || nextProps.billId && nextProps.billId !== this.props.billId) {
                this.setState({ appCode: nextProps.appCode, billId: nextProps.billId }, this.loadFiles);
            }
            if (nextProps.disabled !== undefined && nextProps.disabled !== this.props.disabled) {
                this.setState({ disabled: nextProps.disabled });
            }
        }

        // 加载附件列表


        // 上传前的回调


        // 获取上传的参数


        // 上传文件


        // 预览图片


        // 删除附件


        // 关闭预览窗口

    }, {
        key: 'changeValue',


        // 回调外部form或者table的onChange事件，回传附件id
        value: function changeValue() {
            var files = this.state.files;

            var fileIds = [];
            files.map(function (file) {
                if (file.status === "done" && file.response) {
                    var fileData = file.response.data[0];
                    if (fileData && fileData.pk_doc) {
                        fileIds.push(fileData.pk_doc);
                    }
                }
            });
            if (this.props.onChange && typeof this.props.onChange === "function") {
                this.props.onChange(fileIds.join(","));
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                serverUrl = _props.serverUrl,
                uploadUrl = _props.uploadUrl,
                buttonText = _props.buttonText,
                maxCount = _props.maxCount;

            var action = serverUrl + uploadUrl;
            var _state = this.state,
                files = _state.files,
                disabled = _state.disabled,
                previewVisible = _state.previewVisible,
                previewImage = _state.previewImage;

            var maxCountDisabled = maxCount !== 0 && files.length >= maxCount;
            return _react2.default.createElement(
                'div',
                { style: this.props.style },
                _react2.default.createElement(
                    _yylibUi.YYUpload,
                    _extends({}, this.props, {
                        beforeUpload: this.beforeUpload,
                        onChange: this.onChange,
                        data: this.getUploadParams,
                        withCredentials: true,
                        action: action,
                        fileList: files,
                        disabled: disabled || maxCountDisabled,
                        onPreview: this.onPreview,
                        onRemove: this.onRemove,
                        accept: 'image/gif,image/jpeg,image/jpg,image/png',
                        listType: 'picture-card'
                    }),
                    _react2.default.createElement(
                        'div',
                        null,
                        _react2.default.createElement(_yylibUi.YYIcon, { type: 'plus' }),
                        _react2.default.createElement(
                            'div',
                            { className: 'ant-upload-text' },
                            buttonText
                        )
                    )
                ),
                _react2.default.createElement(
                    _yylibUi.YYModal,
                    { title: '\u56FE\u7247\u9884\u89C8', visible: previewVisible, width: '400',
                        footer: _react2.default.createElement(
                            _yylibUi.YYButton,
                            { ghost: true, type: 'error', style: { backgroundColor: "#FFF" },
                                onClick: this.handleCancel },
                            '\u5173\u95ED'
                        ),
                        maskClosable: false,
                        onCancel: this.handleCancel },
                    _react2.default.createElement('img', { alt: '', style: { width: '100%' }, src: previewImage })
                )
            );
        }
    }]);

    return NccImageWall;
}(_react2.default.Component);

exports.default = NccImageWall;


NccImageWall.defaultProps = {
    disabled: false, // 是否禁用(不允许上传和删除)
    defaultFileList: [], // 默认上传的文件列表
    serverUrl: window.EnvConfig.ATTACH_BASE_URL, // 附件服务基准地址
    queryUrl: '/nccloud/platform/attachment/query.do', // 查询附件的服务地址
    uploadUrl: '/nccloud/platform/attachment/upload.do', // 上传文件的服务地址
    deleteUrl: '/nccloud/platform/attachment/delete.do', // 删除附件的服务地址
    downloadUrl: '/nccloud/platform/attachment/download.do', // 下载附件的服务地址
    showUploadList: true, // 是否显示已上传的文件列表
    buttonText: "点击上传", // 按钮文本
    maxCount: 0, // 最大上传数量
    deleteTip: '删除的附件不可恢复，您确定要继续删除吗？', // 删除附件时提示内容
    multiple: false // 是否允许批量上传
};