'use strict';

/**
 * 筛选栏-单选项组件
 */
var React = require('react');
var _ = require('lodash');
var classnames = require('classnames');

var _require = require('yylib-ui'),
    YYRow = _require.YYRow,
    YYCol = _require.YYCol;

var YYFilterSingle = React.createClass({
    displayName: 'YYFilterSingle',

    getDefaultProps: function getDefaultProps() {
        return {
            rowKey: '', //行标识键值
            showAll: false, //是否显示全部
            minCount: 8, //最少显示个数
            defaultActivedKey: '', //默认激活项
            items: [], //{value: 1, text: '显示的文字'} value不可重复
            onClick: null, //点击单选时的回调函数
            colSpan: 3 //每个单位所占比例，24等份
        };
    },
    getInitialState: function getInitialState() {
        return {
            activeKey: this.props.defaultActivedKey
        };
    },
    componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
        if ("defaultActivedKey" in nextProps && (nextProps.defaultActivedKey !== this.props.defaultActivedKey || nextProps.defaultActivedKey == '')) {
            this.setState({
                activeKey: nextProps.defaultActivedKey
            });
        }
    },
    _handleClick: function _handleClick(item) {
        var _props = this.props,
            onClick = _props.onClick,
            rowKey = _props.rowKey;
        var activeKey = this.state.activeKey;

        var hasSelected = activeKey === item.value ? true : false;
        if (!item.disabled) {
            if (hasSelected) {
                this.setState({ activeKey: '' });
            } else {
                this.setState({ activeKey: item.value });
            }
            if (onClick) {
                onClick(item, !hasSelected, rowKey);
            }
        } else {
            // if (onClick) {
            //     onClick(item, hasSelected);
            // }
        }
    },
    _getItemsData: function _getItemsData(items) {
        var _props2 = this.props,
            showAll = _props2.showAll,
            minCount = _props2.minCount;


        return !showAll && items.length > minCount ? _.slice(items, 0, minCount) : items;
    },
    _renderContent: function _renderContent() {
        var _this = this;
        var _props3 = this.props,
            items = _props3.items,
            colSpan = _props3.colSpan;
        var activeKey = this.state.activeKey;


        return _.map(this._getItemsData(items), function (item, index) {
            var cls = classnames({
                'yyui-filter-item': true,
                'disabled': item.disabled,
                'actived': activeKey === item.value
            });
            return React.createElement(
                YYCol,
                { span: colSpan },
                React.createElement(
                    'span',
                    {
                        className: cls,
                        value: item.value,
                        onClick: _this._handleClick.bind(_this, item),
                        title: item.text
                    },
                    item.text
                )
            );
        });
    },
    render: function render() {
        //判断是否展开，并显示滚动条样式
        var rowCls = classnames({
            'expand': this.props.showAll,
            'yyui-filter-single': true
        });
        return React.createElement(
            YYRow,
            { className: rowCls },
            this._renderContent()
        );
    }
});

module.exports = YYFilterSingle;