'use strict';

/**
 * 导航目标组件
 */
var React = require('react');
var YYClass = require('../../yylib2/base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;
var uiMeta = {
    name: 'steptarget',
    fields: [,
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('targetKey', '', PropTypes.string, true, '依据此属性找到对应DOM,页面唯一'), field('text', null, PropTypes.string, true, '组件显示文字')]
};
var YYStepsTarget = YYClass.create({
    render: function render() {
        var _props = this.props,
            targetKey = _props.targetKey,
            text = _props.text,
            children = _props.children;

        if (!children && text) {
            return React.createElement(
                'span',
                { className: targetKey },
                text
            );
        } else {
            return React.createElement(
                'span',
                { className: targetKey },
                children
            );
        }
    }
});
module.exports = YYStepsTarget;