"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.download = download;
exports.downloadFromFs = downloadFromFs;
exports.downloadFromFsById = downloadFromFsById;

/**
 * 文件下载工具
 *
 * @author 张远志
 * @time 2017年4月14日14:35:31
 */
var _require = require('yylib-business/attach/attachaction'),
    loadAttachList = _require.loadAttachList,
    delAttach = _require.delAttach,
    showErrMsg = _require.showErrMsg,
    downloadUrl = _require.downloadUrl,
    listUrl = _require.listUrl,
    uploadUrl = _require.uploadUrl,
    delUrl = _require.delUrl;

var AuthToken = require("yylib-utils/AuthToken");

/**
 * 文件下载
 * @param url
 * @param params
 * @param option
 */
function download(url, params, option) {
    if (option == undefined || option.type == "form") {
        var form = document.createElement('form');
        form.setAttribute("method", "get");
        form.setAttribute("action", url);
        if (params) {
            for (var key in params) {
                var item = document.createElement("input");
                item.setAttribute("name", key);
                item.setAttribute("value", params[key]);
                form.appendChild(item);
            }
        }
        document.body.appendChild(form);
        form.submit();
        document.body.removeChild(form);
    } else {
        var xhr = new XMLHttpRequest();
        xhr.responseType = "blob";
        xhr.open("POST", url, true);
        xhr.setRequestHeader("Content-Type", "application/json");
        xhr.setRequestHeader("authority", AuthToken.getAuthenticationStr());
        xhr.setRequestHeader("icop-token", AuthToken.getToken());
        xhr.onreadystatechange = function () {
            if (this.readyState == 4 && this.status == 200) {
                var filename = xhr.getResponseHeader("File-Name");
                if (filename != null) {
                    var _url = window.URL.createObjectURL(this.response);
                    var a = document.createElement('a');
                    a.href = _url;
                    a.download = decodeURIComponent(filename);
                    a.click();
                    window.URL.revokeObjectURL(_url);
                } else if (option.onError) {
                    var reader = new FileReader();
                    reader.onload = function (event) {
                        option.onError(event.target.result);
                    };
                    reader.readAsText(this.response);
                }
            }
        };
        xhr.send(JSON.stringify(params));
    }
}

function downloadFromFs(serverUrl, datas) {
    download(serverUrl + downloadUrl, datas);
}

function downloadFromFsById(serverUrl, id) {
    download(serverUrl + downloadUrl.substring(0, downloadUrl.indexOf("?")), { id: id });
}