'use strict';

/**
 * 气泡确认框组件
 */
var React = require('react');
var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;

var _require = require('antd'),
    Popconfirm = _require.Popconfirm;

require('./style/index.less');
//定义META
var uiMeta = {
    name: 'popconfirm',
    fields: [
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('placement', 'top', PropTypes.oneOf(['top', 'left', 'right', 'bottom', 'topLeft', 'topRight', 'bottomLeft', 'bottomRight', 'leftTop', 'leftBottom', 'rightTop', 'rightBottom']), false, '气泡框位置'), field('title', null, PropTypes.element, false, '确认框的描述'), field('onConfirm', null, PropTypes.func, false, '点击确认的回调'), field('onCancel', null, PropTypes.func, false, '点击取消的回调'), field('okText', '确定', PropTypes.string, false, '确认按钮文字'), field('cancelText', '取消', PropTypes.string, false, '取消按钮文字'), field('openClassName', '', PropTypes.string, false, '气泡框展现时触发器添加的类名,可用于打开浮层时高亮触发器')]
};
var YYPopconfirm = YYClass.create({
    uiMeta: uiMeta,
    render: function render() {
        var cls = this.className();
        return React.createElement(
            'div',
            { className: cls },
            React.createElement(
                Popconfirm,
                this.props,
                this.props.children
            )
        );
    }
});
module.exports = YYPopconfirm;