'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * Created by office on 2016/7/29.
 */
var React = require('react');
var assign = require('lodash/assign');
var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;

var _require = require('antd'),
    Spin = _require.Spin;

require('./style/index.less');
//定义META
var uiMeta = {
    name: 'spin',
    fields: [field('size', 'default', PropTypes.oneOf(['default', 'small', 'large']), false, 'spin组件中点的大小'), field('spinning', true, PropTypes.bool, false, '用于内嵌其他组件的模式，可以关闭 loading 效果'), field('tip', null, PropTypes.string, false, '自定义描述文案')]
};
var YYSpin = YYClass.create({
    uiMeta: uiMeta,

    componentDidUpdate: function componentDidUpdate(prevProps, prevState) {
        if (prevProps.spinning) {
            var parentDom = document.querySelector('.yyui-app');
            var _dotHandle = document.querySelector('.ant-spin-nested-loading .ant-spin .ant-spin-dot');
            if (parentDom && _dotHandle) {
                if (parentDom.clientHeight < parentDom.scrollHeight) {
                    _dotHandle.style.top = Math.round((parentDom.scrollTop + parentDom.clientHeight / 2) / parentDom.scrollHeight * 100) + '%';
                }
            }
        }
    },

    render: function render() {
        var cls = this.className();

        return React.createElement(
            'div',
            { className: cls, style: this.props.style },
            React.createElement(
                Spin,
                _extends({}, this.props, { style: null }),
                this.props.children
            )
        );
    }
});
module.exports = YYSpin;